Unit Menu;

     INTERFACE

Uses Crt,Dos,Janela;

type Listopcao = array[1..20] of String[30];
     Tipo_de_Menu = (Vertical,Horizontal);

const
     Vazio : Listopcao =
     ('','','','','','','','','','','','','','','','','','','','');


type  Menus = object
          x,y  : Integer;  { Ancora }
          x1,y1: Integer;  { Extremos do Menu }
          Lista: Listopcao;{ Lista de opcoes }
          Posicao: Byte;   { Posicao da barra }
          Posmax : Byte;   { Posicao Maxima da barra }
          Corback,
          Cortext,
          Cordest,
          Corbarra,
          Corborda,             { Cores do menu [1..15] }
          Tipo_Moldura  : Byte; { e tipo da moldura     }

          constructor Init(a,b:Integer;L:Listopcao );
          procedure Coloremenu(bc,t,dt,br,bd,md: Byte);
          procedure Poebarra;Virtual;
          procedure Tirabarra;Virtual;
          procedure Movebarra(pos:Integer);
          procedure Movimenta;Virtual;
          procedure Movemenu(c,l:Integer);Virtual;
          procedure Apaga;Virtual;
          procedure Mostra;Virtual;
          function Tipo_Menu : Tipo_de_Menu;Virtual;
          function Opcao : byte;
          destructor Destroi;Virtual;
     End;

     Menu_Texto = object(Menus)
          Jnl: Ponteiro_Para_Janela;{Contera o fundo sobreposto pela janela }
          procedure Movemenu(c,l:Integer);Virtual;
          procedure Movimenta;Virtual;
     End;

     Menu_texto_vertical = object(Menu_Texto)
          procedure Mostra;Virtual;
          procedure Apaga;Virtual;
          procedure Poebarra;Virtual;
          procedure Tirabarra;Virtual;
          function Tipo_Menu : Tipo_de_Menu;Virtual;
     End;

     Menu_texto_horizontal = object(Menu_Texto)
          procedure Mostra;Virtual;
          procedure Apaga;Virtual;
          procedure Poebarra;Virtual;
          procedure Tirabarra;Virtual;
          function Tipo_Menu : Tipo_de_Menu;Virtual;
     End;

Procedure Ajusta_Cursor (primeira, ultima : integer);

Implementation

Constructor Menus.Init(a,b:integer; L:Listopcao);
Begin
  x:=a;
  y:=b;{Ancora}
  x1 := 0;{ Utilizados para saber os pontos extremos do menu}
  y1 := 0;{ no procedimento Movemenu}
  Lista:=L;
  Corback:=0;
  Cortext:=15;
  Cordest:=0;
  Corbarra:=5;
  Corborda:=0;
  Tipo_Moldura:=3;
  Posicao:=0;{ Posicao da barra }
End;

Procedure Menus.Coloremenu(bc,t,dt,br,bd,md:Byte);
Begin
  Corback:=bc;
  Cortext:=t;
  Cordest:=dt;
  Corbarra:=br;
  Corborda:=bd;
  Tipo_Moldura:=md;
End;

Procedure Menus.Movemenu(c,l:Integer);
Begin
End;

Procedure Menus.Mostra;
Begin;
End;

Procedure Menus.Apaga;
Begin;
End;

Procedure Menus.Poebarra;
Begin
End;

Procedure Menus.Tirabarra;
Begin
End;

Function Menus.Tipo_Menu : Tipo_de_Menu ;
Begin
End;

Procedure Menus.Movebarra(Pos:Integer);

Begin
  Tirabarra;
  if Pos<0 then Pos:=Posmax-2
            else if Pos>Posmax-2 then Pos:=0;
  Posicao:=Pos;
  Poebarra;
End;


Procedure Menus.Movimenta;
Begin
End;


Function Menus.Opcao : Byte;
Var Ch:Word;
    Status : Byte absolute $0000:$0417;
Begin
    repeat
      Ch:=word(Readkey);
      if (status and 16) <> 16 then
      Begin
        if Tipo_Menu = horizontal then
             Case (char(Ch and 255)) of
                 #27 :  begin
                         Opcao := 0;
                         exit;
                        end;
                #75 : Movebarra(Posicao-1);
                #77 : Movebarra(Posicao+1);
             End
        else
             Case (char(Ch and 255)) of
                 #27 :  begin
                         Opcao := 0;
                         exit;
                        end;
                 #72 : Movebarra(Posicao-1);
                 #80 : Movebarra(Posicao+1);
             End;
         {Letra : Movebarra(Posicao no menu da letra de destaque);
                  Posicao:=Posicao da letra no menu;
                  Ch:=#13=Enter }
      End
      else movimenta;
    until (char(Ch)=#13) or (char(Ch)=#27); { Enter }
    Opcao := Posicao + 1;
End;

Destructor Menus.Destroi;
Begin
End;

(**************************************************************************)
Procedure Menu_Texto.Movimenta;
Var Ch:Word;
    Status :Byte absolute $000:$0417;

Begin
  repeat
    Ch:=Word(Readkey);
    Case (Char(Ch and 255)) of
       #77{'K'} : Movemenu(x+1,y);
       #75{'M'} : Movemenu(x-1,y);
       #80{'L'} : Movemenu(x,y+1);
       #72{'N'} : Movemenu(x,y-1);
    End;
  until (status and 16) <> 16;
  { (Char(Ch)=#13) or (Char(Ch)=#27);  Enter ou Esc }
End;

Procedure Menu_Texto.Movemenu(c,l:Integer);
Begin
  Apaga;
  if (l>0) and (l<(25-(y1-y))) and (l<>y) then
                                           Begin
                                             y1:=y1+l-y;
                                             y:=l;
                                           End;
  if (c>0) and (c<(81-(x1-x))) and (c<>x) then
                                           Begin
                                             x1:=x1+c-x;
                                             x:=c;
                                           End;
  Mostra;
End;

Procedure Menu_Texto_Vertical.Mostra;
Var f,    {Contador auxiliar }
    Maxlen:Integer;

Begin
 if (x1=0) and (y1 = 0) then  {Primeira Vez }
  Begin
    Posmax:=1;
    Maxlen:=0;
    while(Lista[Posmax]<>'') and (posmax<>31) do {acha numero de opcoes do menu}
     Begin
      inc(Posmax);
      if Length(Lista[Posmax])>Maxlen then Maxlen:=Length(Lista[Posmax]);
     End;
    if Maxlen>30 then
     Begin
      Writeln('ERRO: LARGURA INVALIDA DE OPCAO ');
      HALT;
     End;
    x1:=x+Maxlen+3;{Coluna}
    y1:=y+Posmax;{Linha}
  End;
  Salve_Janela(y,x,y1,x1,Jnl);
  TextBackGround(0); {Para nao alterar a cor de fundo na borda}
  Moldura(y,x,y1,x1,Tipo_Moldura);
  Clrscr;
  TextBackGround(Corback);
  TextColor(Cortext);{ nao vai mudar a cortext?}
  For f:=1 to Posmax-1 do
    Begin
      Gotoxy(2,f);
      Write(Lista[f]);
    End;
  Poebarra;
End;

Procedure Menu_Texto_Vertical.Apaga;
Begin
  Feche_Janela(Jnl);
  Window(1,1,80,25);
  TextBackGround(0);
  TextColor(15);
End;

Procedure Menu_Texto_Vertical.Poebarra;
Begin
  TextBackGround(Corbarra);
  TextColor(Cortext);{ nao vai mudar a cortext?}
  Gotoxy(2,Posicao+1);
  Write(Lista[Posicao+1]);
End;

Procedure Menu_Texto_Vertical.Tirabarra;
Begin
  TextBackGround(Corback);
  TextColor(Cortext);{ nao vai mudar a cortext?}
  Gotoxy(2,Posicao+1);
  Write(Lista[Posicao+1]);
End;


Function Menu_Texto_Vertical.Tipo_Menu : Tipo_de_Menu ;
Begin
  Tipo_Menu := vertical;
End;

(*************************************************************************)

Procedure Menu_Texto_Horizontal.Mostra;
Var f,    {Contador auxiliar }
    Maxlen:Integer;
Begin
  Begin
    Posmax:=1;
    Maxlen:=0;
    while(Lista[Posmax]<>'') and (posmax<>31) do {acha numero de opcoes do menu}
     Begin
      inc(Posmax);
      if Length(Lista[Posmax])>Maxlen then Maxlen:=Length(Lista[Posmax]);
     End;
    if Maxlen>12 then
     Begin
      Writeln('ERRO: LARGURA INVALIDA DE OPCAO ');
      HALT;
     End;
    x1:=x+(Posmax-1)*12;{Coluna}
    y1:=y+2;{Linha}
  End;
  Salve_Janela(y,x,y1,x1,Jnl);
  TextBackGround(0); {Para nao alterar a cor de fundo na borda}
  Moldura(y,x,y1,x1,Tipo_Moldura);
  TextBackGround(Corback);
  TextColor(Cortext);{ nao vai mudar a cortext?}
  Clrscr;
  For f:=1 to Posmax-1 do
    Begin
      Gotoxy(2+(f-1)*12,1);
      Write(Lista[f]);
    End;
  Poebarra; {Aquele!!!}
end;

Procedure Menu_Texto_Horizontal.Apaga;
Begin
  Feche_Janela(Jnl);
  Window(1,1,80,25);
  TextBackGround(0);
  TextColor(15);
End;

Procedure Menu_Texto_Horizontal.Poebarra;
Begin
  TextBackGround(Corbarra);
  TextColor(Cortext);{ nao vai mudar a cortext?}
  Gotoxy(2+(Posicao)*12,1);
  Write(Lista[Posicao+1]);
End;

Procedure Menu_Texto_Horizontal.Tirabarra;
Begin
  TextBackGround(Corback);
  TextColor(Cortext);{ nao vai mudar a cortext?}
  Gotoxy(2+(Posicao)*12,1);
  Write(Lista[Posicao+1]);
End;

Function Menu_Texto_Horizontal.Tipo_Menu : Tipo_de_Menu ;
Begin
  Tipo_Menu := horizontal;
End;

Procedure Ajusta_Cursor (primeira, ultima : integer);
var
   Regs : Registers;
   Cor  :Boolean;
begin { ajusta cursor }
  Regs.AH := 1;
  Regs.AL := 0;
  If ((Primeira=0) AND (Ultima=0))
     then Regs.CH := 32
     else begin
            Regs.CH := Primeira;
            Regs.CL := Ultima;
          end;
  Intr(16,Regs);
end;   { ajusta cursor }

End.
